#include "tssFix8Digit.h"
//---------------------------------------------------------------------------
/*     () 
  .
   2-  :
	-1		10
	 0		00
	 1		01
8-       32-  int. */
//---------------------------------------------------------------------------
float tss2dot6ToFloat(int tss)
{/* ,  2    , 6     ,
               float */
    float res = 0.;
    int tmp;

    tmp = (tss & GetTrit7Oct) >> 14;
    if(tmp == 2)
        tmp = -1;
    res += tmp * 3.f;

    tmp = (tss & GetTrit6Oct) >> 12;
    if(tmp == 2)
        tmp = -1;
    res += tmp * 1.f;

    tmp = (tss & GetTrit5Oct) >> 10;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 3.f;

    tmp = (tss & GetTrit4Oct) >> 8;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 9.f;

    tmp = (tss & GetTrit3Oct) >> 6;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 27.f;

    tmp = (tss & GetTrit2Oct) >> 4;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 81.f;

    tmp = (tss & GetTrit1Oct) >> 2;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 243.f;

    tmp = tss & GetTrit0Oct;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 729.f;

    return(res);
}
//---------------------------------------------------------------------------
void printTss2dot6(int tss)
{/*     2    ,
                            6     .*/
    int resultH = 0, resultL = 0;

    resultH = tss & GetHalfTrit15Oct;
    resultL = tss & GetHalfTrit14Oct;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

//    printf(".");

    resultH = tss & GetHalfTrit13Oct;
    resultL = tss & GetHalfTrit12Oct;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

	printf(".");

    resultH = tss & GetHalfTrit11Oct;
    resultL = tss & GetHalfTrit10Oct;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit09Oct;
    resultL = tss & GetHalfTrit08Oct;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit07Oct;
    resultL = tss & GetHalfTrit06Oct;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit05Oct;
    resultL = tss & GetHalfTrit04Oct;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit03Oct;
    resultL = tss & GetHalfTrit02Oct;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit01Oct;
    resultL = tss & GetHalfTrit00Oct;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");
}
//---------------------------------------------------------------------------
int subTss8Digit(int leftTss, int rigthTss)
{/*   .
      .*/

    int rTss;

    rTss = inversTss8Digit(rigthTss);
    rTss = addTss8Digit(leftTss, rTss);

    return(rTss);//  !
}
//---------------------------------------------------------------------------
int inversTss8Digit(int tss)
{/*  ,  TSS . 
  ,  .
  ,  .
 .*/
	int tssHigh, tssLow;

	tssHigh = (tss & reduHighOct) >> 1;
	tssLow = (tss & reduLowOct) << 1;
	
	return(tssLow | tssHigh);
}
//---------------------------------------------------------------------------
int getSignTss8Digit(int tss)
{/*  TSS .     , 
   ,      .
70,000000t => 32768d = 1000000000000000b
11,111111t => 21845d = 0101010101010101b*/
	int tssHigh, tssLow;

	tssHigh = tss & reduHighOct;
	tssLow = tss & reduLowOct;
	
	return(tssLow - tssHigh);//   ? 
}
//---------------------------------------------------------------------------
int shiftRightTss8Digit(int tss, int count)
{/*   count  (count*2  )*/
    int tmp;//, i;

//    i = count * 2;
    tmp = tss >> count;
    tmp >>= count;
	return(tmp);
}
//---------------------------------------------------------------------------
int atanTss8Digit(int tssY)
{/*       CORDIC.*/
    int ang = 0, i = 0, xTmp, x = 4096/*coPlusOne*/,  y = tssY, yTmp;

    for(i = 0; i < 9; i++)
    {// 1- 
        xTmp = x;
        yTmp = y;
        xTmp = shiftRightTss8Digit(xTmp, i);
        yTmp = shiftRightTss8Digit(yTmp, i);
        if(getSignTss8Digit(y) < 0)
        {
            yTmp = inversTss8Digit(yTmp);
            ang = subTss8Digit(ang, atanArOct[i]);
        }else
        {
            xTmp = inversTss8Digit(xTmp);
            ang = addTss8Digit(ang, atanArOct[i]);
        }
        x = addTss8Digit(x, yTmp);
        y = addTss8Digit(y, xTmp);
     // 2- 
        xTmp = x;
        yTmp = y;
        xTmp = shiftRightTss8Digit(xTmp, i);
        yTmp = shiftRightTss8Digit(yTmp, i);
        if(getSignTss8Digit(y) < 0)
        {
            yTmp = inversTss8Digit(yTmp);
            ang = subTss8Digit(ang, atanArOct[i]);
        }else
        {
            xTmp = inversTss8Digit(xTmp);
            ang = addTss8Digit(ang, atanArOct[i]);
        }
        x = addTss8Digit(x, yTmp);
        y = addTss8Digit(y, xTmp);
    }
//    ang = nornAfterAtanTss10Digit(ang);
//    ang = ang >> 2;
    return(ang);
}
//---------------------------------------------------------------------------
int addTss8Digit(int left, int right)
{//  2- TSS     .
// ,      ,      .
	int leftShift, rightShift, carryHigh, carryLow, tritHigh, tritLow;

//0 trit
	leftShift = left >> 1;	//   
	rightShift = right >> 1;
	carryHigh = (leftShift &~left & rightShift &~right) << 3;
	carryLow = (~leftShift & left &~rightShift & right) << 2;
	tritHigh =(( leftShift &~left &~rightShift &~right)|(~leftShift &~left & rightShift &~right)|(~leftShift & left &~rightShift & right)) << 1;
	tritLow = ( leftShift &~left & rightShift &~right)|(~leftShift &~left &~rightShift & right)|(~leftShift & left &~rightShift &~right);
	carryHigh &= reduHighOct;
	tritHigh &= reduHighOct;
	carryLow &= reduLowOct;
	tritLow &= reduLowOct;
	left = carryHigh | carryLow;
	right = tritHigh | tritLow;
//0 trit
//1 trit
	leftShift = left >> 1;
	rightShift = right >> 1;
	carryHigh = (leftShift &~left & rightShift &~right) << 3;
	carryLow = (~leftShift & left &~rightShift & right) << 2;
	tritHigh =(( leftShift &~left &~rightShift &~right)|(~leftShift &~left & rightShift &~right)|(~leftShift & left &~rightShift & right)) << 1;
	tritLow = ( leftShift &~left & rightShift &~right)|(~leftShift &~left &~rightShift & right)|(~leftShift & left &~rightShift &~right);
	carryHigh &= reduHighOct;
	tritHigh &= reduHighOct;
	carryLow &= reduLowOct;
	tritLow &= reduLowOct;
	left = carryHigh | carryLow;
	right = tritHigh | tritLow;
//1 trit
//2 trit
	leftShift = left >> 1;
	rightShift = right >> 1;
	carryHigh = (leftShift &~left & rightShift &~right) << 3;
	carryLow = (~leftShift & left &~rightShift & right) << 2;
	tritHigh =(( leftShift &~left &~rightShift &~right)|(~leftShift &~left & rightShift &~right)|(~leftShift & left &~rightShift & right)) << 1;
	tritLow = ( leftShift &~left & rightShift &~right)|(~leftShift &~left &~rightShift & right)|(~leftShift & left &~rightShift &~right);
	carryHigh &= reduHighOct;
	tritHigh &= reduHighOct;
	carryLow &= reduLowOct;
	tritLow &= reduLowOct;
	left = carryHigh | carryLow;
	right = tritHigh | tritLow;
//2 trit
//3 trit
	leftShift = left >> 1;
	rightShift = right >> 1;
	carryHigh = (leftShift &~left & rightShift &~right) << 3;
	carryLow = (~leftShift & left &~rightShift & right) << 2;
	tritHigh =(( leftShift &~left &~rightShift &~right)|(~leftShift &~left & rightShift &~right)|(~leftShift & left &~rightShift & right)) << 1;
	tritLow = ( leftShift &~left & rightShift &~right)|(~leftShift &~left &~rightShift & right)|(~leftShift & left &~rightShift &~right);
	carryHigh &= reduHighOct;
	tritHigh &= reduHighOct;
	carryLow &= reduLowOct;
	tritLow &= reduLowOct;
	left = carryHigh | carryLow;
	right = tritHigh | tritLow;
//3 trit
//4 trit
	leftShift = left >> 1;
	rightShift = right >> 1;
	carryHigh = (leftShift &~left & rightShift &~right) << 3;
	carryLow = (~leftShift & left &~rightShift & right) << 2;
	tritHigh =(( leftShift &~left &~rightShift &~right)|(~leftShift &~left & rightShift &~right)|(~leftShift & left &~rightShift & right)) << 1;
	tritLow = ( leftShift &~left & rightShift &~right)|(~leftShift &~left &~rightShift & right)|(~leftShift & left &~rightShift &~right);
	carryHigh &= reduHighOct;
	tritHigh &= reduHighOct;
	carryLow &= reduLowOct;
	tritLow &= reduLowOct;
	left = carryHigh | carryLow;
	right = tritHigh | tritLow;
//4 trit
//5 trit
	leftShift = left >> 1;
	rightShift = right >> 1;
	carryHigh = (leftShift &~left & rightShift &~right) << 3;
	carryLow = (~leftShift & left &~rightShift & right) << 2;
	tritHigh =(( leftShift &~left &~rightShift &~right)|(~leftShift &~left & rightShift &~right)|(~leftShift & left &~rightShift & right)) << 1;
	tritLow = ( leftShift &~left & rightShift &~right)|(~leftShift &~left &~rightShift & right)|(~leftShift & left &~rightShift &~right);
	carryHigh &= reduHighOct;
	tritHigh &= reduHighOct;
	carryLow &= reduLowOct;
	tritLow &= reduLowOct;
	left = carryHigh | carryLow;
	right = tritHigh | tritLow;
//5 trit
//6 trit
	leftShift = left >> 1;
	rightShift = right >> 1;
	carryHigh = (leftShift &~left & rightShift &~right) << 3;
	carryLow = (~leftShift & left &~rightShift & right) << 2;
	tritHigh =(( leftShift &~left &~rightShift &~right)|(~leftShift &~left & rightShift &~right)|(~leftShift & left &~rightShift & right)) << 1;
	tritLow = ( leftShift &~left & rightShift &~right)|(~leftShift &~left &~rightShift & right)|(~leftShift & left &~rightShift &~right);
	carryHigh &= reduHighOct;
	tritHigh &= reduHighOct;
	carryLow &= reduLowOct;
	tritLow &= reduLowOct;
	left = carryHigh | carryLow;
	right = tritHigh | tritLow;
//6 trit
//7 trit
	leftShift = left >> 1;
	rightShift = right >> 1;
	carryHigh = (leftShift &~left & rightShift &~right) << 3;
	carryLow = (~leftShift & left &~rightShift & right) << 2;
	tritHigh =(( leftShift &~left &~rightShift &~right)|(~leftShift &~left & rightShift &~right)|(~leftShift & left &~rightShift & right)) << 1;
	tritLow = ( leftShift &~left & rightShift &~right)|(~leftShift &~left &~rightShift & right)|(~leftShift & left &~rightShift &~right);
	carryHigh &= reduHighOct;
	tritHigh &= reduHighOct;
	carryLow &= reduLowOct;
	tritLow &= reduLowOct;
	left = carryHigh | carryLow;
	right = tritHigh | tritLow;
//7 trit
//8 trit
//8 trit
	return(right);
}
//---------------------------------------------------------------------------
