#include "tssfix10digit4k1921.h"
//---------------------------------------------------------------------------
const int   MakeTritZero0 = 1048572, MakeTritPlus0 =      1, MakeTritMinus0 = 2,
            MakeTritZero1 = 1048563, MakeTritPlus1 =      4, MakeTritMinus1 = 8,
            MakeTritZero2 = 1048527, MakeTritPlus2 =     16, MakeTritMinus2 = 32,
            MakeTritZero3 = 1048383, MakeTritPlus3 =     64, MakeTritMinus3 = 128,
            MakeTritZero4 = 1047807, MakeTritPlus4 =    256, MakeTritMinus4 = 512,
            MakeTritZero5 = 1045503, MakeTritPlus5 =   1024, MakeTritMinus5 = 2048,
            MakeTritZero6 = 1036287, MakeTritPlus6 =   4098, MakeTritMinus6 = 8192,
            MakeTritZero7 =  999423, MakeTritPlus7 =  16384, MakeTritMinus7 = 32768,
            MakeTritZero8 =  851967, MakeTritPlus8 =  65536, MakeTritMinus8 = 131072,
            MakeTritZero9 =  262143, MakeTritPlus9 = 262144, MakeTritMinus9 = 524288,
            GetTrit0 =      3, GetTrit1 =    12, GetTrit2 =     48,
            GetTrit3 =    192, GetTrit4 =   768, GetTrit5 =   3072,
            GetTrit6 =  12288, GetTrit7 = 49152, 
						GetTrit8 = 196608,
            GetTrit9 = 786432,
            Bin2tssBit00 = 1,
            Bin2tssBit01 = 6,
            Bin2tssBit02 = 5,
            Bin2tssBit03 = 18,
            Bin2tssBit04 = 105,
            Bin2tssBit05 = 90,
            Bin2tssBit06 = 401,
            Bin2tssBit07 = 1702,
            Bin2tssBit08 = 1045,
            Bin2tssBit09 = 6210,
            Bin2tssBit10 = 5513,
            Bin2tssBit11 = 18762,
            Bin2tssBit12 = 100513,
            Bin2tssBit13 = 91670,

            GetHalfTrit00 = 1,      GetHalfTrit01 = 2,      GetHalfTrit02 = 4,
            GetHalfTrit03 = 8,      GetHalfTrit04 = 16,     GetHalfTrit05 = 32,
            GetHalfTrit06 = 64,     GetHalfTrit07 = 128,    GetHalfTrit08 = 256,
            GetHalfTrit09 = 512,    GetHalfTrit10 = 1024,   GetHalfTrit11 = 2048,
            GetHalfTrit12 = 4096,   GetHalfTrit13 = 8192,   GetHalfTrit14 = 16384,
            GetHalfTrit15 = 32768,  GetHalfTrit16 = 65536,  GetHalfTrit17 = 131072,
            GetHalfTrit18 = 262144, GetHalfTrit19 = 524288,
            coPlusOne = 10379, coMinusOne = 6005, coZero = 8192, coMinimum = 170281,
//            atanAr[]={411176, 67688, 16416, 4096, 1024, 256, 64, 16, 4, 1}
            atanAr[]={102794, 16922, 4104, 1024, 256, 64, 16, 4, 1, 0};
//const char *version="version 0.1";
//---------------------------------------------------------------------------
/*Реализована троичная сбалансированная система счисления (ТСС) с фиксированной запятой.
Значения тритов кодируется 2-х битными полями:
-1	кодируется	10
0	кодируется	00
1	кодируется	01

10-и разрядное ТСС число храниться в 20-и младших разрядах 32-х битного int.
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
/*Объявление служебных функций (перенесены из заголовочного файла).*/

int inversTss10Digit(int tss);
/**Инверсия ТСС числа, изменение знака.
Проверяются значения 2-х битовых полей.
Если одно из полей не равно единице,
то обнуляется 2-х битовое поле и
устанавливается соответствующий бит в 2-х битовом поле.*/
//---------------------------------------------------------------------------
int tss10Digit2Int(int tss);
/*Преобразование 10-и разрядного ТСС числа в 32-х битный int.
Проверяются значения 2-х битовых полей.
Если одно из полей не равно единице,
то прибавляется/отнимается соответствующая степень тройки.*/
//---------------------------------------------------------------------------
void printfTss10Digit(int tss);
/*Вывод на экран 10-и разрядного ТСС числа, символ -1 обозначается символом 7.
Проверяются значения 2-х битовых полей.
Если старший бит не равен нулю, то печатаем символ «7»,
если младший бит не равен нулю, то печатаем символ «1»,
                в противном случае печатаем символ «0».*/
//---------------------------------------------------------------------------
int getSignNumber(int tss);
/*Возвращает знак и номер старшего трита*/
//---------------------------------------------------------------------------
int shiftLeft(int tss, int count);
/*Сдвиг вправо на count трит (count*2 двухбитовых полей)*/
//---------------------------------------------------------------------------
int shiftRight(int tss, int count);
/*Сдвиг вправо на count трит (count*2 двухбитовых полей)*/
//---------------------------------------------------------------------------
int subTss10Digit(int leftTss, int rigthTss);
/*Целочисленное вычитание ТСС чисел.
Реализовано через инверсию правого операнда и сложение.*/
//---------------------------------------------------------------------------
int nornAfterAtanTss10Digit(int tss);
/*Нормализация результата после арктангенса.

Можно увеличить точность на трит, для этого
надо реализовать сложение 11-и тритовых чисел.*/

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void getVersion(char *currentVersion)
/*Возвращает номер версии библиотеки*/
{
    int i;

    for(i = 0; i < 12; i++);
        //currentVersion[i] = version[i];
}
//---------------------------------------------------------------------------
int atanTss10Digit(int tssY)
/*Вычисляет арктангенс угла с использованием быстродействующего алгоритма CORDIC.*/
{
    int ang = 0, i = 0, xTmp, x = 16384/*coPlusOne*/,  y = tssY, yTmp;

    for(i = 0; i < 10; i++)
    {// 1-я итерация
        xTmp = x;
        yTmp = y;
        xTmp = shiftRight(xTmp, i);
        yTmp = shiftRight(yTmp, i);
        if(getSignNumber(y) < 0)
        {
            yTmp = inversTss10Digit(yTmp);
            ang = subTss10Digit(ang, atanAr[i]);
        }else
        {
            xTmp = inversTss10Digit(xTmp);
            ang = addTss10Digit(ang, atanAr[i]);
        }
        x = addTss10Digit(x, yTmp);
        y = addTss10Digit(y, xTmp);
     // 2-я итерация
        xTmp = x;
        yTmp = y;
        xTmp = shiftRight(xTmp, i);
        yTmp = shiftRight(yTmp, i);
        if(getSignNumber(y) < 0)
        {
            yTmp = inversTss10Digit(yTmp);
            ang = subTss10Digit(ang, atanAr[i]);
        }else
        {
            xTmp = inversTss10Digit(xTmp);
            ang = addTss10Digit(ang, atanAr[i]);
        }
        x = addTss10Digit(x, yTmp);
        y = addTss10Digit(y, xTmp);
    }
//    ang = nornAfterAtanTss10Digit(ang);
    ang = ang >> 2;
    return(ang);
}
//---------------------------------------------------------------------------
int getSignNumber(int tss)
/*Возвращает знак и номер старшего трита*/
{
    int i, tmp;

    for(i = 9; i >= 0; i--)
    {
        tmp = tss >> (i * 2);
        if(tmp == 2)
        {
            tmp = -1;
            break;
        }
        else if(tmp == 1)
            break;
    }
    i *= tmp;
    return(i);
}
//---------------------------------------------------------------------------
int shiftLeft(int tss, int count)
/*Сдвиг вправо на count трит (count*2 двухбитовых полей)*/
{
    int tmp, i;

    i = count * 2;
    tmp = tss << i;
    return(tmp);
}
//---------------------------------------------------------------------------
int shiftRight(int tss, int count)
/*Сдвиг вправо на count трит (count*2 двухбитовых полей)*/
{
    int tmp, i;

    i = count * 2;
    tmp = tss >> i;
    return(tmp);
}
//---------------------------------------------------------------------------
int int2tss10Digit(int bin)
/*Преобразование int в 10-и разрядное ТСС число.
Преобразуются целые положительные числа в диапазоне от 0 до 16383.
Проверяются значения битов двоичного числа.
Если бит не равен нулю, то производиться сложение с соответствующей ТСС константой.*/
{
    int res = 0, tmp;

    tmp = bin &                 GetHalfTrit00;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit00);
    tmp = bin &                 GetHalfTrit01;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit01);
    tmp = bin &                 GetHalfTrit02;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit02);
    tmp = bin &                 GetHalfTrit03;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit03);
    tmp = bin &                 GetHalfTrit04;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit04);
    tmp = bin &                 GetHalfTrit05;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit05);
    tmp = bin &                 GetHalfTrit06;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit06);
    tmp = bin &                 GetHalfTrit07;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit07);
    tmp = bin &                 GetHalfTrit08;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit08);
    tmp = bin &                 GetHalfTrit09;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit09);
    tmp = bin &                 GetHalfTrit10;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit10);
    tmp = bin &                 GetHalfTrit11;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit11);
    tmp = bin &                 GetHalfTrit12;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit12);
    tmp = bin &                 GetHalfTrit13;
    if(tmp != 0)
        res = addTss10Digit(res, Bin2tssBit13);

    return res;
}
//---------------------------------------------------------------------------
int subTss10Digit(int leftTss, int rigthTss)
/*Целочисленное вычитание ТСС чисел.
Реализовано через инверсию правого операнда и сложение.*/
{
    int rTss;

    rTss = inversTss10Digit(rigthTss);
    rTss = addTss10Digit(leftTss, rTss);

    return(rTss);
}
//---------------------------------------------------------------------------
int addTss10Digit(int leftTss, int rigthTss)
/*Целочисленное сложение ТСС чисел.
Реализовано поразрядно сложение с учетом переноса.
Для каждого разряда проверятся 27 возможных комбинаций операндов.
Требуемый результат формируется сдвигами.
*/
{
    int result, carryNxL, carryNxH, carryNext = 0, carryTrit, valueTrit, leftH, leftL, rigthH, rigthL;

// 0 trit
    carryNxL = carryNext & 1;
    carryNxH = (carryNext & 2) >> 1;
    rigthL = rigthTss & GetHalfTrit00;
    leftL  = leftTss  & GetHalfTrit00;
    rigthH = (rigthTss & GetHalfTrit01) >> 1;
    leftH  = (leftTss  & GetHalfTrit01) >> 1;
    valueTrit = 0; carryTrit = 0;
    if(carryNxH == 0 && carryNxL == 0)  // carryNext = 0
    {   if(leftH == 0 && leftL == 1)
        {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0;
            else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
            else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
        else if(leftH == 0 && leftL == 0)
        {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
            else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
            else                                valueTrit = 1/*plus*/;}
        else if(leftH == 1 && leftL == 0)
        {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/;  carryTrit = 2/*minus*/;}
            else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
            else                                valueTrit = 0;}    }
    else if(carryNxH == 0 && carryNxL && 1)  // carryNext = 1
    {   if(leftH == 0 && leftL == 1)
        {   if(rigthH == 1 && rigthL == 0)      valueTrit = 1;
            else if(rigthH == 0 && rigthL == 0){valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}
            else                               {valueTrit = 0; carryTrit = 1/*plus*/;}}
        else if(leftH == 0 && leftL == 0)
        {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0/*minus*/;
            else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
            else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
        else if(leftH == 1 && leftL == 0)
        {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2 /*minus*/;
            else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
            else                                valueTrit = 1/*plus*/;}    }
    else                                    //carryNext = -1
    {   if(leftH == 0 && leftL == 1)
        {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
            else if(rigthH == 0 && rigthL == 0) valueTrit = 0;// carryTrit ;
            else                                valueTrit = 1/*plus*/;}
        else if(leftH == 0 && leftL == 0)
        {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
            else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
            else                                valueTrit = 0; }
        else if(leftH == 1 && leftL == 0)
        {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 0; carryTrit = 2/*minus*/;}
            else if(rigthH == 0 && rigthL == 0){valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
            else                                valueTrit = 2/*minus*/;}    }
    carryNext = carryTrit;
    result = valueTrit;
// 0 trit
// 1 trit
    carryNxL = carryNext & 1;
    carryNxH = (carryNext & 2) >> 1;
    rigthL = (rigthTss & GetHalfTrit02) >> 2;
    leftL  = (leftTss  & GetHalfTrit02) >> 2;
    rigthH = (rigthTss & GetHalfTrit03) >> 3;
    leftH  = (leftTss  & GetHalfTrit03) >> 3;
    valueTrit = 0; carryTrit = 0;
    if(carryNxH == 0 && carryNxL == 0)  // carryNext = 0
    {   if(leftH == 0 && leftL == 1)
        {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0;
            else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
            else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
        else if(leftH == 0 && leftL == 0)
        {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
            else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
            else                                valueTrit = 1/*plus*/;}
        else if(leftH == 1 && leftL == 0)
        {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/;  carryTrit = 2/*minus*/;}
            else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
            else                                valueTrit = 0;}    }
    else if(carryNxH == 0 && carryNxL && 1)  // carryNext = 1
    {   if(leftH == 0 && leftL == 1)
        {   if(rigthH == 1 && rigthL == 0)      valueTrit = 1;
            else if(rigthH == 0 && rigthL == 0){valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}
            else                               {valueTrit = 0; carryTrit = 1/*plus*/;}}
        else if(leftH == 0 && leftL == 0)
        {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0/*minus*/;
            else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
            else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
        else if(leftH == 1 && leftL == 0)
        {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2 /*minus*/;
            else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
            else                                valueTrit = 1/*plus*/;}    }
    else                                    //carryNext = -1
    {   if(leftH == 0 && leftL == 1)
        {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
            else if(rigthH == 0 && rigthL == 0) valueTrit = 0;// carryTrit ;
            else                                valueTrit = 1/*plus*/;}
        else if(leftH == 0 && leftL == 0)
        {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
            else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
            else                                valueTrit = 0; }
        else if(leftH == 1 && leftL == 0)
        {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 0; carryTrit = 2/*minus*/;}
            else if(rigthH == 0 && rigthL == 0){valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
            else                                valueTrit = 2/*minus*/;}    }
    carryNext = carryTrit;
    result = (valueTrit << 2) | result;
// 1 trit
// 2 trit
        carryNxL = carryNext & 1;
        carryNxH = (carryNext & 2) >> 1;
        rigthL = (rigthTss & GetHalfTrit04) >> 4;
        leftL  = (leftTss  & GetHalfTrit04) >> 4;
        rigthH = (rigthTss & GetHalfTrit05) >> 5;
        leftH  = (leftTss  & GetHalfTrit05) >> 5;
        valueTrit = 0; carryTrit = 0;
        if(carryNxH == 0 && carryNxL == 0)  // carryNext = 0
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/;  carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0;}    }
        else if(carryNxH == 0 && carryNxL && 1)  // carryNext = 1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 1;
                else if(rigthH == 0 && rigthL == 0){valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}
                else                               {valueTrit = 0; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2 /*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}    }
        else                                    //carryNext = -1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;// carryTrit ;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0; }
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 0; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0){valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else                                valueTrit = 2/*minus*/;}    }
        carryNext = carryTrit;
        result = (valueTrit << 4) | result;
// 2 trit
//3 trit
        carryNxL = carryNext & 1;
        carryNxH = (carryNext & 2) >> 1;
        rigthL = (rigthTss & GetHalfTrit06) >> 6;
        leftL  = (leftTss  & GetHalfTrit06) >> 6;
        rigthH = (rigthTss & GetHalfTrit07) >> 7;
        leftH  = (leftTss  & GetHalfTrit07) >> 7;
        valueTrit = 0; carryTrit = 0;
        if(carryNxH == 0 && carryNxL == 0)  // carryNext = 0
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/;  carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0;}    }
        else if(carryNxH == 0 && carryNxL && 1)  // carryNext = 1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 1;
                else if(rigthH == 0 && rigthL == 0){valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}
                else                               {valueTrit = 0; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2 /*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}    }
        else                                    //carryNext = -1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;// carryTrit ;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0; }
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 0; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0){valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else                                valueTrit = 2/*minus*/;}    }
        carryNext = carryTrit;
        result = (valueTrit << 6) | result;
//3 trit
// 4 trit
        carryNxL = carryNext & 1;
        carryNxH = (carryNext & 2) >> 1;
        rigthL = (rigthTss & GetHalfTrit08) >> 8;
        leftL  = (leftTss  & GetHalfTrit08) >> 8;
        rigthH = (rigthTss & GetHalfTrit09) >> 9;
        leftH  = (leftTss  & GetHalfTrit09) >> 9;
        valueTrit = 0; carryTrit = 0;
        if(carryNxH == 0 && carryNxL == 0)  // carryNext = 0
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/;  carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0;}    }
        else if(carryNxH == 0 && carryNxL && 1)  // carryNext = 1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 1;
                else if(rigthH == 0 && rigthL == 0){valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}
                else                               {valueTrit = 0; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2 /*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}    }
        else                                    //carryNext = -1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;// carryTrit ;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0; }
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 0; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0){valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else                                valueTrit = 2/*minus*/;}    }
        carryNext = carryTrit;
        result = (valueTrit << 8) | result;
// 4 trit
//5 trit
        carryNxL = carryNext & 1;
        carryNxH = (carryNext & 2) >> 1;
        rigthL = (rigthTss & GetHalfTrit10) >> 10;
        leftL  = (leftTss  & GetHalfTrit10) >> 10;
        rigthH = (rigthTss & GetHalfTrit11) >> 11;
        leftH  = (leftTss  & GetHalfTrit11) >> 11;
        valueTrit = 0; carryTrit = 0;
        if(carryNxH == 0 && carryNxL == 0)  // carryNext = 0
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/;  carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0;}    }
        else if(carryNxH == 0 && carryNxL && 1)  // carryNext = 1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 1;
                else if(rigthH == 0 && rigthL == 0){valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}
                else                               {valueTrit = 0; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2 /*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}    }
        else                                    //carryNext = -1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;// carryTrit ;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0; }
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 0; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0){valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else                                valueTrit = 2/*minus*/;}    }
        carryNext = carryTrit;
        result = (valueTrit << 10) | result;
//5 trit
//6 trit
        carryNxL = carryNext & 1;
        carryNxH = (carryNext & 2) >> 1;
        rigthL = (rigthTss & GetHalfTrit12) >> 12;
        leftL  = (leftTss  & GetHalfTrit12) >> 12;
        rigthH = (rigthTss & GetHalfTrit13) >> 13;
        leftH  = (leftTss  & GetHalfTrit13) >> 13;
        valueTrit = 0; carryTrit = 0;
        if(carryNxH == 0 && carryNxL == 0)  // carryNext = 0
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/;  carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0;}    }
        else if(carryNxH == 0 && carryNxL && 1)  // carryNext = 1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 1;
                else if(rigthH == 0 && rigthL == 0){valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}
                else                               {valueTrit = 0; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2 /*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}    }
        else                                    //carryNext = -1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;// carryTrit ;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0; }
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 0; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0){valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else                                valueTrit = 2/*minus*/;}    }
        carryNext = carryTrit;
        result = (valueTrit << 12) | result;
//6 trit
//7 trit
        carryNxL = carryNext & 1;
        carryNxH = (carryNext & 2) >> 1;
        rigthL = (rigthTss & GetHalfTrit14) >> 14;
        leftL  = (leftTss  & GetHalfTrit14) >> 14;
        rigthH = (rigthTss & GetHalfTrit15) >> 15;
        leftH  = (leftTss  & GetHalfTrit15) >> 15;
        valueTrit = 0; carryTrit = 0;
        if(carryNxH == 0 && carryNxL == 0)  // carryNext = 0
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/;  carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0;}    }
        else if(carryNxH == 0 && carryNxL && 1)  // carryNext = 1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 1;
                else if(rigthH == 0 && rigthL == 0){valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}
                else                               {valueTrit = 0; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2 /*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}    }
        else                                    //carryNext = -1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;// carryTrit ;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0; }
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 0; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0){valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else                                valueTrit = 2/*minus*/;}    }
        carryNext = carryTrit;
        result = (valueTrit << 14) | result;
//7 trit
//8 trit
        carryNxL = carryNext & 1;
        carryNxH = (carryNext & 2) >> 1;
        rigthL = (rigthTss & GetHalfTrit16) >> 16;
        leftL  = (leftTss  & GetHalfTrit16) >> 16;
        rigthH = (rigthTss & GetHalfTrit17) >> 17;
        leftH  = (leftTss  & GetHalfTrit17) >> 17;
        valueTrit = 0; carryTrit = 0;
        if(carryNxH == 0 && carryNxL == 0)  // carryNext = 0
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/;  carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0;}    }
        else if(carryNxH == 0 && carryNxL && 1)  // carryNext = 1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 1;
                else if(rigthH == 0 && rigthL == 0){valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}
                else                               {valueTrit = 0; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2 /*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}    }
        else                                    //carryNext = -1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;// carryTrit ;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0; }
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 0; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0){valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else                                valueTrit = 2/*minus*/;}    }
        carryNext = carryTrit;
        result = (valueTrit << 16) | result;
//8 trit
//9 trit
        carryNxL = carryNext & 1;
        carryNxH = (carryNext & 2) >> 1;
        rigthL = (rigthTss & GetHalfTrit18) >> 18;
        leftL  = (leftTss  & GetHalfTrit18) >> 18;
        rigthH = (rigthTss & GetHalfTrit19) >> 19;
        leftH  = (leftTss  & GetHalfTrit19) >> 19;
        valueTrit = 0; carryTrit = 0;
        if(carryNxH == 0 && carryNxL == 0)  // carryNext = 0
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/;  carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0;}    }
        else if(carryNxH == 0 && carryNxL && 1)  // carryNext = 1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 1;
                else if(rigthH == 0 && rigthL == 0){valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}
                else                               {valueTrit = 0; carryTrit = 1/*plus*/;}}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 0/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 1/*plus*/;
                else                               {valueTrit = 2/*minus*/; carryTrit = 1/*plus*/;}}
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2 /*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;
                else                                valueTrit = 1/*plus*/;}    }
        else                                    //carryNext = -1
        {   if(leftH == 0 && leftL == 1)
            {   if(rigthH == 1 && rigthL == 0)      valueTrit = 2/*minus*/;
                else if(rigthH == 0 && rigthL == 0) valueTrit = 0;// carryTrit ;
                else                                valueTrit = 1/*plus*/;}
            else if(leftH == 0 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0) valueTrit = 2/*minus*/;
                else                                valueTrit = 0; }
            else if(leftH == 1 && leftL == 0)
            {   if(rigthH == 1 && rigthL == 0)     {valueTrit = 0; carryTrit = 2/*minus*/;}
                else if(rigthH == 0 && rigthL == 0){valueTrit = 1/*plus*/; carryTrit = 2/*minus*/;}
                else                                valueTrit = 2/*minus*/;}    }
        carryNext = carryTrit;
        result = (valueTrit << 18) | result;
//9 trit
    return result;
}
//---------------------------------------------------------------------------
int inversTss10Digit(int tss)
/*Инверсия ТСС числа, изменение знака.
Проверяются значения 2-х битовых полей.
Если одно из полей не равно единице,
то обнуляется 2-х битовое поле и
устанавливается соответствующий бит в 2-х битовом поле.*/
{
    int resultH = 0, resultL = 0, tmp = 0;

    resultH = tss & GetHalfTrit19;
    resultL = tss & GetHalfTrit18;
    if(resultH != 0)
    {
        tmp = tss & MakeTritZero9;
        tss = tmp | MakeTritPlus9;
    }
    else if(resultL != 0)
    {
        tmp = tss & MakeTritZero9;
        tss = tmp | MakeTritMinus9;
    }

    resultH = tss & GetHalfTrit17;
    resultL = tss & GetHalfTrit16;
    if(resultH != 0)
    {
        tmp = tss & MakeTritZero8;
        tss = tmp | MakeTritPlus8;
    }
    else if(resultL != 0)
    {
        tmp = tss & MakeTritZero8;
        tss = tmp | MakeTritMinus8;
    }

    resultH = tss & GetHalfTrit15;
    resultL = tss & GetHalfTrit14;
    if(resultH != 0)
    {
        tmp = tss & MakeTritZero7;
        tss = tmp | MakeTritPlus7;
    }
    else if(resultL != 0)
    {
        tmp = tss & MakeTritZero7;
        tss = tmp | MakeTritMinus7;
    }

    resultH = tss & GetHalfTrit13;
    resultL = tss & GetHalfTrit12;
    if(resultH != 0)
    {
        tmp = tss & MakeTritZero6;
        tss = tmp | MakeTritPlus6;
    }
    else if(resultL != 0)
    {
        tmp = tss & MakeTritZero6;
        tss = tmp | MakeTritMinus6;
    }

    resultH = tss & GetHalfTrit11;
    resultL = tss & GetHalfTrit10;
    if(resultH != 0)
    {
        tmp = tss & MakeTritZero5;
        tss = tmp | MakeTritPlus5;
    }
    else if(resultL != 0)
    {
        tmp = tss & MakeTritZero5;
        tss = tmp | MakeTritMinus5;
    }

    resultH = tss & GetHalfTrit09;
    resultL = tss & GetHalfTrit08;
    if(resultH != 0)
    {
        tmp = tss & MakeTritZero4;
        tss = tmp | MakeTritPlus4;
    }
    else if(resultL != 0)
    {
        tmp = tss & MakeTritZero4;
        tss = tmp | MakeTritMinus4;
    }

    resultH = tss & GetHalfTrit07;
    resultL = tss & GetHalfTrit06;
    if(resultH != 0)
    {
        tmp = tss & MakeTritZero3;
        tss = tmp | MakeTritPlus3;
    }
    else if(resultL != 0)
    {
        tmp = tss & MakeTritZero3;
        tss = tmp | MakeTritMinus3;
    }

    resultH = tss & GetHalfTrit05;
    resultL = tss & GetHalfTrit04;
    if(resultH != 0)
    {
        tmp = tss & MakeTritZero2;
        tss = tmp | MakeTritPlus2;
    }
    else if(resultL != 0)
    {
        tmp = tss & MakeTritZero2;
        tss = tmp | MakeTritMinus2;
    }

    resultH = tss & GetHalfTrit03;
    resultL = tss & GetHalfTrit02;
    if(resultH != 0)
    {
        tmp = tss & MakeTritZero1;
        tss = tmp | MakeTritPlus1;
    }
    else if(resultL != 0)
    {
        tmp = tss & MakeTritZero1;
        tss = tmp | MakeTritMinus1;
    }

    resultH = tss & GetHalfTrit01;
    resultL = tss & GetHalfTrit00;
    if(resultH != 0)
    {
        tmp = tss & MakeTritZero0;
        tss = tmp | MakeTritPlus0;
    }
    else if(resultL != 0)
    {
        tmp = tss & MakeTritZero0;
        tss = tmp | MakeTritMinus0;
    }
//    tmp = tss;

    return tss;
}
//---------------------------------------------------------------------------
void printTss3dot7(int tss)
/*Вывод ТСС числа в формате 3 трита – целая часть,
                            7 трит после запятой – дробная.*/
{
    int resultH = 0, resultL = 0;

    resultH = tss & GetHalfTrit19;
    resultL = tss & GetHalfTrit18;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit17;
    resultL = tss & GetHalfTrit16;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit15;
    resultL = tss & GetHalfTrit14;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    printf(".");

    resultH = tss & GetHalfTrit13;
    resultL = tss & GetHalfTrit12;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit11;
    resultL = tss & GetHalfTrit10;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit09;
    resultL = tss & GetHalfTrit08;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit07;
    resultL = tss & GetHalfTrit06;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit05;
    resultL = tss & GetHalfTrit04;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit03;
    resultL = tss & GetHalfTrit02;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit01;
    resultL = tss & GetHalfTrit00;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");
}
//---------------------------------------------------------------------------
int nornAfterAtanTss10Digit(int tss)
/*Нормализация результата после арктангенса.

Можно увеличить точность на трит, для этого
надо реализовать сложение 11-и тритовых чисел.*/
{
    int tmp8;//, tmp7, tmp6;

    tmp8 = tss & GetTrit8;
/*    tmp7 = tss & GetTrit7;
    tmp6 = tss & GetTrit6;*/
    if(tmp8 != 0)
        return(tss >> 2);
/*    else if((tmp7 == 0) &&(tmp6 != 0))
        return(tss << 2);
    else*/
        return(tss);
}
//---------------------------------------------------------------------------
float tss3dot7ToFloat(int tss)
/*ТСС число, формата 3 трита – целая часть, 7 трит после запятой – дробная,
             преобразуется в float */
{
    float res = 0.;
    int tmp;

    tmp = (tss & GetTrit9) >> 18;
    if(tmp == 2)
        tmp = -1;
    res += tmp * 9.f;

    tmp = (tss & GetTrit8) >> 16;
    if(tmp == 2)
        tmp = -1;
    res += tmp * 3.f;

    tmp = (tss & GetTrit7) >> 14;
    if(tmp == 2)
        tmp = -1;
    res += tmp * 1.f;

    tmp = (tss & GetTrit6) >> 12;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 3.f;

    tmp = (tss & GetTrit5) >> 10;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 9.f;

    tmp = (tss & GetTrit4) >> 8;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 27.f;

    tmp = (tss & GetTrit3) >> 6;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 81.f;

    tmp = (tss & GetTrit2) >> 4;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 243.f;

    tmp = (tss & GetTrit1) >> 2;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 729.f;

    tmp = tss & GetTrit0;
    if(tmp == 2)
        tmp = -1;
    res += tmp / 2187.f;

    return(res);
}
//---------------------------------------------------------------------------
int tss10Digit2Int(int tss)
/*Преобразование 10-и разрядного ТСС числа в 32-х битный int.
Проверяются значения 2-х битовых полей.
Если одно из полей не равно единице,
то прибавляется/отнимается соответствующая степень тройки.
*/
{
    int resultH = 0, resultL = 0, ret = 0;

    resultH = tss & GetHalfTrit19;
    resultL = tss & GetHalfTrit18;
    if     (resultH != 0)
        ret -= 19683;
    else if(resultL != 0)
        ret += 19683;

    resultH = tss & GetHalfTrit17;
    resultL = tss & GetHalfTrit16;
    if     (resultH != 0)
        ret -= 6561;
    else if(resultL != 0)
        ret += 6561;

    resultH = tss & GetHalfTrit15;
    resultL = tss & GetHalfTrit14;
    if     (resultH != 0)
        ret -= 2187;
    else if(resultL != 0)
        ret += 2187;

    resultH = tss & GetHalfTrit13;
    resultL = tss & GetHalfTrit12;
    if     (resultH != 0)
        ret -= 729;
    else if(resultL != 0)
        ret += 729;

    resultH = tss & GetHalfTrit11;
    resultL = tss & GetHalfTrit10;
    if     (resultH != 0)
        ret -= 243;
    else if(resultL != 0)
        ret += 243;

    resultH = tss & GetHalfTrit09;
    resultL = tss & GetHalfTrit08;
    if     (resultH != 0)
        ret -= 81;
    else if(resultL != 0)
        ret += 81;

    resultH = tss & GetHalfTrit07;
    resultL = tss & GetHalfTrit06;
    if     (resultH != 0)
        ret -= 27;
    else if(resultL != 0)
        ret += 27;

    resultH = tss & GetHalfTrit05;
    resultL = tss & GetHalfTrit04;
    if     (resultH != 0)
        ret -= 9;
    else if(resultL != 0)
        ret += 9;

    resultH = tss & GetHalfTrit03;
    resultL = tss & GetHalfTrit02;
    if     (resultH != 0)
        ret -= 3;
    else if(resultL != 0)
        ret += 3;

    resultH = tss & GetHalfTrit01;
    resultL = tss & GetHalfTrit00;
    if     (resultH != 0)
        ret -= 1;
    else if(resultL != 0)
        ret += 1;

//    printf("\n");
    return(ret);
}
//---------------------------------------------------------------------------
void printfTss10Digit(int tss)
/*Вывод на экран 10-и разрядного ТСС числа, символ -1 обозначается символом 7.
Проверяются значения 2-х битовых полей.
Если старший бит не равен нулю, то печатаем символ «7»,
если младший бит не равен нулю, то печатаем символ «1»,
                в противном случае печатаем символ «0».
*/
{
    int resultH = 0, resultL = 0;

    resultH = tss & GetHalfTrit19;
    resultL = tss & GetHalfTrit18;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit17;
    resultL = tss & GetHalfTrit16;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit15;
    resultL = tss & GetHalfTrit14;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit13;
    resultL = tss & GetHalfTrit12;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit11;
    resultL = tss & GetHalfTrit10;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit09;
    resultL = tss & GetHalfTrit08;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit07;
    resultL = tss & GetHalfTrit06;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit05;
    resultL = tss & GetHalfTrit04;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit03;
    resultL = tss & GetHalfTrit02;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

    resultH = tss & GetHalfTrit01;
    resultL = tss & GetHalfTrit00;
    if     (resultH != 0)
        printf("7");
    else if(resultL != 0)
        printf("1");
    else
        printf("0");

//    printf("\n");
}
//---------------------------------------------------------------------------
