#ifndef TSSFIX10DIGIT_H
#define TSSFIX10DIGIT_H

//#include<stdio.h>
//---------------------------------------------------------------------------
/*Реализована троичная сбалансированная система счисления (ТСС) с фиксированной запятой.
Значения тритов кодируется 2-х битными полями:
-1	кодируется	10
0	кодируется	00
1	кодируется	01

10-и разрядное ТСС число храниться в 20-и младших разрядах 32-х битного int.
*/
//---------------------------------------------------------------------------
int atanTss10Digit(int tssY);
/*Вычисляет арктангенс угла с использованием быстродействующего алгоритма CORDIC.*/
//---------------------------------------------------------------------------
void printTss3dot7(int tss);
/*Вывод на экран 10-и разрядного ТСС числа, символ -1 обозначается символом 7.
Проверяются значения 2-х битовых полей.
Если старший бит не равен нулю, то печатаем символ «7»,
если младший бит не равен нулю, то печатаем символ «1»,
                в противном случае печатаем символ «0».*/
//---------------------------------------------------------------------------
float tss3dot7ToFloat(int tss);
/*ТСС число, формата 3 трита – целая часть, 7 трит после запятой – дробная,
             преобразуется в float */
//---------------------------------------------------------------------------
int int2tss10Digit(int bin);
/*Преобразование int в 10-и разрядное ТСС число.
Преобразуются целые положительные числа в диапазоне от 0 до 16383.
Проверяются значения битов двоичного числа.
Если бит не равен нулю, то производиться сложение с соответствующей ТСС константой.*/
//---------------------------------------------------------------------------
int addTss10Digit(int leftTss, int rigthTss);
/*Целочисленное сложение ТСС чисел.
Реализовано поразрядно сложение с учетом переноса.
Для каждого разряда проверятся 27 возможных комбинаций операндов.
Требуемый результат формируется сдвигами.*/
//---------------------------------------------------------------------------
void getVersion(char *currentVersion);
/*Возвращает номер версии библиотеки*/
//---------------------------------------------------------------------------
#endif // TSSFIX10DIGIT_H
